## mingw-w64-qxorm-1.5.0-1.src.tar.zst

=== CMakeLists.txt ===
#############################################################################
##
## https://www.qxorm.com/
## Copyright (C) 2013 Lionel Marty (contact@qxorm.com)
##
## This file is part of the QxOrm library
##
## This software is provided 'as-is', without any express or implied
## warranty. In no event will the authors be held liable for any
## damages arising from the use of this software
##
## Commercial Usage
## Licensees holding valid commercial QxOrm licenses may use this file in
## accordance with the commercial license agreement provided with the
## Software or, alternatively, in accordance with the terms contained in
## a written agreement between you and Lionel Marty
##
## GNU General Public License Usage
## Alternatively, this file may be used under the terms of the GNU
## General Public License version 3.0 as published by the Free Software
## Foundation and appearing in the file 'license.gpl3.txt' included in the
## packaging of this file. Please review the following information to
## ensure the GNU General Public License version 3.0 requirements will be
## met : http://www.gnu.org/copyleft/gpl.html
##
## If you are unsure which license is appropriate for your use, or
## if you have questions regarding the use of this file, please contact :
## contact@qxorm.com
##
#############################################################################

cmake_minimum_required(VERSION 3.1)

project(QxOrm VERSION 1.5.0 LANGUAGES CXX)

# Include QxOrm library configuration file (should be included by all projects which depend on QxOrm)
include(./QxOrm.cmake)

set(CMAKE_AUTOMOC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_DEBUG_POSTFIX "d")

set(QX_HEADERS
    ./include/QxPrecompiled.h
    ./include/QxMemLeak/bool_array.h
    ./include/QxMemLeak/class_level_lock.h
    ./include/QxMemLeak/cont_ptr_utils.h
    ./include/QxMemLeak/debug_new.h
    ./include/QxMemLeak/fast_mutex.h
    ./include/QxMemLeak/fixed_mem_pool.h
    ./include/QxMemLeak/mem_leak.h
    ./include/QxMemLeak/mem_pool_base.h
    ./include/QxMemLeak/object_level_lock.h
    ./include/QxMemLeak/pctimer.h
    ./include/QxMemLeak/set_assign.h
    ./include/QxMemLeak/static_assert.h
    ./include/QxMemLeak/static_mem_pool.h
    ./include/QxSingleton/IxSingleton.h
    ./include/QxSingleton/QxSingleton.h
    ./include/QxSingleton/QxSingletonX.h
    ./include/QxSingleton/QxSingletonInit.h
    ./include/QxFactory/IxFactory.h
    ./include/QxFactory/QxFactory.h
    ./include/QxFactory/QxFactoryX.h
    ./include/QxCommon/QxConfig.h
    ./include/QxCommon/QxMacro.h
    ./include/QxCommon/QxHashValue.h
    ./include/QxCommon/QxBool.h
    ./include/QxCommon/QxCache.h
    ./include/QxCommon/QxPropertyBag.h
    ./include/QxCommon/QxSimpleCrypt.h
    ./include/QxCommon/QxAnyCastDynamic.h
    ./include/QxCommon/QxException.h
    ./include/QxCommon/QxExceptionCode.h
    ./include/QxCommon/QxAny.h
    ./include/QxConvert/QxConvert.h
    ./include/QxConvert/QxConvert_Impl.h
    ./include/QxConvert/QxConvert_Export.h
    ./include/QxRegister/IxClass.h
    ./include/QxRegister/QxClass.h
    ./include/QxRegister/QxClassX.h
    ./include/QxRegister/QxClassName.h
    ./include/QxRegister/QxRegister.h
    ./include/QxRegister/QxRegisterInternalHelper.h
    ./include/QxRegister/IxTypeInfo.h
    ./include/QxRegister/QxRegisterQtProperty.h
    ./include/QxRegister/QxVersion.h
    ./include/QxCollection/IxCollection.h
    ./include/QxCollection/QxCollection.h
    ./include/QxCollection/QxCollectionIterator.h
    ./include/QxCollection/QxForeach.h
    ./include/QxDataMember/IxDataMember.h
    ./include/QxDataMember/IxDataMemberX.h
    ./include/QxDataMember/QxDataMember.h
    ./include/QxDataMember/QxDataMemberX.h
    ./include/QxDataMember/QxDataMember_QObject.h
    ./include/QxDataMember/QxDataMember_PImpl.h
    ./include/QxDao/IxSqlQueryBuilder.h
    ./include/QxDao/QxSqlQueryBuilder.h
    ./include/QxDao/QxSqlQueryHelper.h
    ./include/QxDao/QxSqlQuery.h
    ./include/QxDao/QxSqlDatabase.h
    ./include/QxDao/IxSqlRelation.h
    ./include/QxDao/QxSqlRelation.h
    ./include/QxDao/QxSqlRelationParams.h
    ./include/QxDao/QxSqlRelation_ManyToMany.h
    ./include/QxDao/QxSqlRelation_ManyToOne.h
    ./include/QxDao/QxSqlRelation_OneToMany.h
    ./include/QxDao/QxSqlRelation_OneToOne.h
    ./include/QxDao/QxSqlRelation_RawData.h
    ./include/QxDao/QxDao.h
    ./include/QxDao/QxDao_Impl.h
    ./include/QxDao/QxDaoStrategy.h
    ./include/QxDao/QxDaoPointer.h
    ./include/QxDao/QxDao_IsDirty.h
    ./include/QxDao/QxSoftDelete.h
    ./include/QxDao/QxSqlError.h
    ./include/QxDao/QxSession.h
    ./include/QxDao/QxDateNeutral.h
    ./include/QxDao/QxTimeNeutral.h
    ./include/QxDao/QxDateTimeNeutral.h
    ./include/QxDao/IxDao_Helper.h
    ./include/QxDao/IxPersistable.h
    ./include/QxDao/IxPersistableCollection.h
    ./include/QxDao/IxPersistableList.h
    ./include/QxDao/QxSqlJoin.h
    ./include/QxDao/QxSqlRelationLinked.h
    ./include/QxDao/QxDaoAsync.h
    ./include/QxDao/QxSqlSaveMode.h
    ./include/QxDao/QxDaoThrowable.h
    ./include/QxDao/QxSqlElement/IxSqlElement.h
    ./include/QxDao/QxSqlElement/QxSqlCompare.h
    ./include/QxDao/QxSqlElement/QxSqlElement.h
    ./include/QxDao/QxSqlElement/QxSqlElementTemp.h
    ./include/QxDao/QxSqlElement/QxSqlEmbedQuery.h
    ./include/QxDao/QxSqlElement/QxSqlExpression.h
    ./include/QxDao/QxSqlElement/QxSqlFreeText.h
    ./include/QxDao/QxSqlElement/QxSqlIn.h
    ./include/QxDao/QxSqlElement/QxSqlIsBetween.h
    ./include/QxDao/QxSqlElement/QxSqlIsNull.h
    ./include/QxDao/QxSqlElement/QxSqlLimit.h
    ./include/QxDao/QxSqlElement/QxSqlSort.h
    ./include/QxDao/QxSqlGenerator/IxSqlGenerator.h
    ./include/QxDao/QxSqlGenerator/QxSqlGenerator.h
    ./include/QxDao/QxSqlGenerator/QxSqlGenerator_MySQL.h
    ./include/QxDao/QxSqlGenerator/QxSqlGenerator_Oracle.h
    ./include/QxDao/QxSqlGenerator/QxSqlGenerator_PostgreSQL.h
    ./include/QxDao/QxSqlGenerator/QxSqlGenerator_SQLite.h
    ./include/QxDao/QxSqlGenerator/QxSqlGenerator_MSSQLServer.h
    ./include/QxDao/QxSqlGenerator/QxSqlGenerator_Standard.h
    ./include/QxDao/QxRepository/IxRepository.h
    ./include/QxDao/QxRepository/QxRepository.h
    ./include/QxDao/QxRepository/QxRepositoryX.h
    ./include/QxDao/QxMongoDB/QxMongoDB_Helper.h
    ./include/QxSerialize/QxArchive.h
    ./include/QxSerialize/QxClone.h
    ./include/QxSerialize/QxDump.h
    ./include/QxSerialize/QxSerializeFastCompil.h
    ./include/QxSerialize/QxSerializeInvoker.h
    ./include/QxSerialize/QxSerializeMacro.h
    ./include/QxSerialize/QxSerialize.h
    ./include/QxSerialize/QxSerializeQDataStream.h
    ./include/QxSerialize/QxSerializeCheckInstance.h
    ./include/QxSerialize/QxSerializeQJson.h
    ./include/QxSerialize/boost/class_export/qx_boost_class_export.h
    ./include/QxSerialize/boost/portable_binary/portable_archive_exception.hpp
    ./include/QxSerialize/boost/portable_binary/portable_iarchive.hpp
    ./include/QxSerialize/boost/portable_binary/portable_oarchive.hpp
    ./include/QxSerialize/boost/QxSerializeInclude.h
    ./include/QxSerialize/boost/QxSerialize_shared_ptr.h
    ./include/QxSerialize/boost/QxSerialize_tuple.h
    ./include/QxSerialize/boost/QxSerialize_unordered_map.h
    ./include/QxSerialize/boost/QxSerialize_unordered_set.h
    ./include/QxSerialize/boost/QxExportDllMacroHpp.h
    ./include/QxSerialize/boost/QxExportDllMacroCpp.h
    ./include/QxSerialize/boost/QxExportDllBoostArchive.h
    ./include/QxSerialize/boost/QxImportDllBoostArchive.h
    ./include/QxSerialize/Qt/QxSerialize_QBrush.h
    ./include/QxSerialize/Qt/QxSerialize_QByteArray.h
    ./include/QxSerialize/Qt/QxSerialize_QColor.h
    ./include/QxSerialize/Qt/QxSerialize_QDate.h
    ./include/QxSerialize/Qt/QxSerialize_QDateTime.h
    ./include/QxSerialize/Qt/QxSerialize_QFont.h
    ./include/QxSerialize/Qt/QxSerialize_QHash.h
    ./include/QxSerialize/Qt/QxSerialize_QImage.h
    ./include/QxSerialize/Qt/QxSerialize_QFlags.h
    ./include/QxSerialize/Qt/QxSerialize_QLinkedList.h
    ./include/QxSerialize/Qt/QxSerialize_QList.h
    ./include/QxSerialize/Qt/QxSerialize_QMap.h
    ./include/QxSerialize/Qt/QxSerialize_QMatrix.h
    ./include/QxSerialize/Qt/QxSerialize_QObject.h
    ./include/QxSerialize/Qt/QxSerialize_QPair.h
    ./include/QxSerialize/Qt/QxSerialize_QPicture.h
    ./include/QxSerialize/Qt/QxSerialize_QPixmap.h
    ./include/QxSerialize/Qt/QxSerialize_QPoint.h
    ./include/QxSerialize/Qt/QxSerialize_QRect.h
    ./include/QxSerialize/Qt/QxSerialize_QRegExp.h
    ./include/QxSerialize/Qt/QxSerialize_QRegion.h
    ./include/QxSerialize/Qt/QxSerialize_QScopedPointer.h
    ./include/QxSerialize/Qt/QxSerialize_QSharedPointer.h
    ./include/QxSerialize/Qt/QxSerialize_QSize.h
    ./include/QxSerialize/Qt/QxSerialize_QString.h
    ./include/QxSerialize/Qt/QxSerialize_QTime.h
    ./include/QxSerialize/Qt/QxSerialize_QUrl.h
    ./include/QxSerialize/Qt/QxSerialize_QUuid.h
    ./include/QxSerialize/Qt/QxSerialize_QVariant.h
    ./include/QxSerialize/Qt/QxSerialize_QVector.h
    ./include/QxSerialize/Qt/QxSerialize_QWeakPointer.h
    ./include/QxSerialize/Qt/QxSerialize_QMultiHash.h
    ./include/QxSerialize/Qt/QxSerialize_QMultiMap.h
    ./include/QxSerialize/Qt/QxSerialize_QStringList.h
    ./include/QxSerialize/Qt/QxSerialize_QSqlError.h
    ./include/QxSerialize/Qx/QxSerialize_QxCollection.h
    ./include/QxSerialize/Qx/QxSerialize_QxDaoPointer.h
    ./include/QxSerialize/std/QxSerialize_std_tuple.h
    ./include/QxSerialize/std/QxSerialize_std_shared_ptr.h
    ./include/QxSerialize/std/QxSerialize_std_unique_ptr.h
    ./include/QxSerialize/std/QxSerialize_std_unordered_map.h
    ./include/QxSerialize/std/QxSerialize_std_unordered_set.h
    ./include/QxSerialize/QxBoostSerializeHelper/IxBoostSerializeRegisterHelper.h
    ./include/QxSerialize/QxBoostSerializeHelper/QxBoostInitGuid.h
    ./include/QxSerialize/QxBoostSerializeHelper/QxBoostSerializeHelper.h
    ./include/QxSerialize/QxBoostSerializeHelper/QxBoostSerializeRegisterHelper.h
    ./include/QxSerialize/QxBoostSerializeHelper/QxBoostSerializeRegisterHelperX.h
    ./include/QxSerialize/QDataStream/QxSerializeQDataStream_all_include.h
    ./include/QxSerialize/QDataStream/QxSerializeQDataStream_boost_optional.h
    ./include/QxSerialize/QDataStream/QxSerializeQDataStream_boost_scoped_ptr.h
    ./include/QxSerialize/QDataStream/QxSerializeQDataStream_boost_shared_ptr.h
    ./include/QxSerialize/QDataStream/QxSerializeQDataStream_boost_tuple.h
    ./include/QxSerialize/QDataStream/QxSerializeQDataStream_boost_unordered_map.h
    ./include/QxSerialize/QDataStream/QxSerializeQDataStream_boost_unordered_set.h
    ./include/QxSerialize/QDataStream/QxSerializeQDataStream_primitive_type.h
    ./include/QxSerialize/QDataStream/QxSerializeQDataStream_QFlags.h
    ./include/QxSerialize/QDataStream/QxSerializeQDataStream_QObject.h
    ./include/QxSerialize/QDataStream/QxSerializeQDataStream_QScopedPointer.h
    ./include/QxSerialize/QDataStream/QxSerializeQDataStream_QSharedPointer.h
    ./include/QxSerialize/QDataStream/QxSerializeQDataStream_QSqlError.h
    ./include/QxSerialize/QDataStream/QxSerializeQDataStream_QWeakPointer.h
    ./include/QxSerialize/QDataStream/QxSerializeQDataStream_std_list.h
    ./include/QxSerialize/QDataStream/QxSerializeQDataStream_std_map.h
    ./include/QxSerialize/QDataStream/QxSerializeQDataStream_std_pair.h
    ./include/QxSerialize/QDataStream/QxSerializeQDataStream_std_set.h
    ./include/QxSerialize/QDataStream/QxSerializeQDataStream_std_shared_ptr.h
    ./include/QxSerialize/QDataStream/QxSerializeQDataStream_std_string.h
    ./include/QxSerialize/QDataStream/QxSerializeQDataStream_std_tuple.h
    ./include/QxSerialize/QDataStream/QxSerializeQDataStream_std_unique_ptr.h
    ./include/QxSerialize/QDataStream/QxSerializeQDataStream_std_unordered_map.h
    ./include/QxSerialize/QDataStream/QxSerializeQDataStream_std_unordered_set.h

=== PKGBUILD ===
# Maintainer: Konstantin Podsvirov <konstantin@podsvirov.pro>

_realname=QxOrm
pkgbase=mingw-w64-${_realname,,}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname,,}"
         "${MINGW_PACKAGE_PREFIX}-${_realname,,}-docs")
pkgver=1.5.0
pkgrel=1
pkgdesc='A C++ Qt ORM (Object Relational Mapping) and ODM (Object Document Mapper) library (mingw-w64)'
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url='https://www.qxorm.com/'
msys2_repository_url='https://github.com/QxOrm/QxOrm'
license=('spdx:GPL-3.0-only')
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs"
         "${MINGW_PACKAGE_PREFIX}-qt6-base")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-doxygen"
             "${MINGW_PACKAGE_PREFIX}-graphviz"
             "${MINGW_PACKAGE_PREFIX}-qt6-tools")
source=("${msys2_repository_url}/archive/${pkgver}/${_realname}-${pkgver}.tar.gz"
        '0001-qxorm-1.4.9-install.patch')
sha256sums=('4e42a15db6a89f08a74f639f805a3c707e3c77b5cab7f66821f07e6a6bc4092e'
            '74b755b0a36c68b39dd291cb324c8bda663d994757908b57b07d7abc8c92c1c6')

prepare() {
    cd "${srcdir}/${_realname}-${pkgver}"

    patch -Np1 -i "${srcdir}"/0001-qxorm-1.4.9-install.patch
}

build() {
    cd "${srcdir}/${_realname}-${pkgver}"/doc/doxygen

    msg2 "Build QxOrm documentation"

    "${MINGW_PREFIX}"/bin/doxygen.exe qxorm.doxygen
}

package_qxorm() {
    cd "${srcdir}/${_realname}-${pkgver}"

    msg2 "Build QxOrm library"

    "${MINGW_PREFIX}"/bin/qmake6.exe CONFIG+=release \
        DEFINES+=_QX_ENABLE_QT_GUI \
        PREFIX="${pkgdir}${MINGW_PREFIX}" \
        QMAKE_CXXFLAGS_RELEASE+="${CXXFLAGS} ${CPPFLAGS} -Wno-deprecated-declarations" \
        QxOrm.pro

    make

    make INSTALL_ROOT="" install

    mkdir -p "${pkgdir}${MINGW_PREFIX}/bin"
    mv "${pkgdir}${MINGW_PREFIX}/lib/"*.dll "${pkgdir}${MINGW_PREFIX}/bin/"

    install -Dm644 license.gpl3.txt ${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname,,}/license.gpl3.txt
}

package_qxorm-docs() {
    cd "${srcdir}/${_realname}-${pkgver}"/doc/doxygen

    pkgdesc+=" (documentation)"
    depends=()

    mkdir -p "${pkgdir}${MINGW_PREFIX}"/share/doc/${_realname,,}
    cp -a html "${pkgdir}${MINGW_PREFIX}"/share/doc/${_realname,,}/
}

# template start; name=mingw-w64-splitpkg-wrappers; version=1.0;
# vim: set ft=bash :

# generate wrappers
for _name in "${pkgname[@]}"; do
    _short="package_${_name#${MINGW_PACKAGE_PREFIX}-}"
    _func="$(declare -f "${_short}")"
    eval "${_func/#${_short}/package_${_name}}"
done
# template end;
